]> arthur.barton.de Git - backup-script.git/commitdiff
Output warning and error messages to stderr
authorAlexander Barton <alex@barton.de>
Mon, 13 Nov 2017 16:40:55 +0000 (17:40 +0100)
committerAlexander Barton <alex@barton.de>
Mon, 13 Nov 2017 16:40:55 +0000 (17:40 +0100)
This allows to filter warning/error messages more easily.

bin/backup-script

index 4ae96d1689c4726fb64ec592415a045ae8e1b031..84180d3e5e0d1c366b2cb7135e2aa13a755a549b 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2016 Alexander Barton <alex@barton.de>
+# Copyright (c)2008-2017 Alexander Barton <alex@barton.de>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,26 +54,32 @@ default_job_post_exec=""
 default_tags=""
 
 Usage() {
-       echo "Usage: $NAME [<options>] [<job> [<job> [...]]]"
-       echo
-       echo "  -n, --dry-run       Test run only, don't copy any data."
-       echo "  -p, --progress      Show progress, see rsync(1)."
-       echo "  -t TAG, --tag TAG   Only run jobs with tag TAG."
-       echo "  -x, --no-exec       Don't run global pre-/post-exec commands."
-       echo
-       echo "When no <job> is given, all defined systems are used."
-       echo
-       # shellcheck disable=SC2086
-       echo -e $config_info
-       echo
+       {
+               echo "Usage: $NAME [<options>] [<job> [<job> [...]]]"
+               echo
+               echo "  -n, --dry-run       Test run only, don't copy any data."
+               echo "  -p, --progress      Show progress, see rsync(1)."
+               echo "  -t TAG, --tag TAG   Only run jobs with tag TAG."
+               echo "  -x, --no-exec       Don't run global pre-/post-exec commands."
+               echo
+               echo "When no <job> is given, all defined systems are used."
+               echo
+               # shellcheck disable=SC2086
+               echo -e $config_info
+               echo
+       } >&2
        exit 2
 }
 
+ErrorMsg () {
+       printf "%s\n" "$@" >&2
+}
+
 CleanUp() {
        if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
                echo "Executing \"$post_exec\" ..."
                if ! sh -c $post_exec; then
-                       echo "Warning: post-exec command failed!"
+                       ErrorMsg "Warning: post-exec command failed!"
                fi
                echo
        fi
@@ -82,10 +88,10 @@ CleanUp() {
 
 GotSignal() {
        echo
-       echo "--> Got signal, cleaning up & aborting ..."
+       ErrorMsg "--> Got signal, cleaning up & aborting ..."
        echo
        CleanUp
-       echo -n "Aborted: "; date
+       ErrorMsg -n "Aborted: " >&2; date
        echo
        sleep 3
        exit 9
@@ -106,9 +112,11 @@ ExecJob() {
                echo " *** Trial run, not executing ${what}-exec command!"
                ret=0
        fi
-       [ $ret -eq 0 ] \
-               && echo "The ${what}-exec command completed with status 0, OK." \
-               || echo "The ${what}-exec command completed with ERRORS, code $ret!"
+       if [ $ret -eq 0 ]; then
+               echo "The ${what}-exec command completed with status 0, OK."
+       else
+               ErrorMsg "The ${what}-exec command completed with ERRORS, code $ret!"
+       fi
        return $ret
 }
 
@@ -142,7 +150,7 @@ CreateSubvolume() {
                zfs create "$(echo "$volume" | cut -c2-)" || return 1
                ;;
          *)
-               echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
+               ErrorMsg "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
                return 9
        esac
        return 0
@@ -170,7 +178,7 @@ CloneSubvolume() {
                        "$(dirname "$volume")/$link_name"
                ;;
          *)
-               echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               ErrorMsg "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
        esac
        return 0
@@ -193,7 +201,7 @@ RenameSubvolume() {
                        || return 1
                ;;
          *)
-               echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               ErrorMsg "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
        esac
        return 0
@@ -221,7 +229,7 @@ DeleteSubvolume() {
                [ -h "$volume" ] && rm "$volume"
                ;;
          *)
-               echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
+               ErrorMsg "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
                return 9
        esac
        return 0
@@ -240,7 +248,7 @@ Initialize_Last_SysTarget_Snapshot() {
                last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
                if [ -n "$last" ]; then
                        if [ ! -d "$last" ]; then
-                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
+                               ErrorMsg "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
                                echo
                                return 1
                        fi
@@ -268,7 +276,7 @@ Initialize_Last_SysTarget_Snapshot() {
                sys_target="$sys_target/current"
                ;;
          *)
-               echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
+               ErrorMsg "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
                return 1
        esac
        return 0
@@ -322,11 +330,11 @@ echo -e "$config_info"
 
 # Check rsync and its protocol version
 if ! rsync=$(which "rsync" 2>/dev/null); then
-       echo "Failed to detect rsync(1)! Is it installed in your \$PATH?"
+       ErrorMsg "Failed to detect rsync(1)! Is it installed in your \$PATH?"
        exit 1
 fi
 if ! rsync_proto=$($rsync --version 2>/dev/null | head -n 1 | sed 's/.*  protocol version \([0-9]*\)$/\1/'); then
-       echo "Failed to detect protocol version of $rsync!"
+       ErrorMsg "Failed to detect protocol version of $rsync!"
        exit 1
 fi
 echo "Rsync command is $rsync, protocol version $rsync_proto."
@@ -337,7 +345,7 @@ echo
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
-                       echo "$NAME: Can' read \"${conf_d}/$s\"!"
+                       ErrorMsg "$NAME: Can' read \"${conf_d}/$s\"!"
                        exit 3
                fi
                sys+=("${conf_d}/$s")
@@ -349,8 +357,8 @@ fi
 if [[ -n "$setup_exec" && $PREPOSTEXEC -ne 0 ]]; then
        echo "Executing \"$setup_exec\" ..."
        if ! sh -c $setup_exec; then
-               echo "Error: setup command failed!"; echo
-               echo "Aborting backup."; echo
+               ErrorMsg "Error: setup command failed!"; echo
+               ErrorMsg "Aborting backup."; echo
                exit 5
        fi
        sleep 2
@@ -361,15 +369,15 @@ trap GotSignal SIGINT SIGTERM
 
 # check and create PID file
 if [ -e "$PIDFILE" ]; then
-       echo "Lockfile \"$PIDFILE\" already exists."
-       echo "Is an other instance still running?"
+       ErrorMsg "Lockfile \"$PIDFILE\" already exists."
+       ErrorMsg "Is an other instance still running?"
        echo
-       echo -n "Aborted: "; date
+       ErrorMsg -n "Aborted: " >&2; date
        echo
        exit 4
 fi
 if ! touch "$PIDFILE" 2>/dev/null; then
-       echo "Warning: can't create PID file \"$PIDFILE\"!"
+       ErrorMsg "Warning: can't create PID file \"$PIDFILE\"!"
        echo
 else
        echo "$$" >>"$PIDFILE"
@@ -378,9 +386,9 @@ fi
 if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
        echo "Executing \"$pre_exec\" ..."
        if ! sh -c $pre_exec; then
-               echo "Error: pre-exec command failed!"; echo
+               ErrorMsg "Error: pre-exec command failed!"; echo
                CleanUp
-               echo "Aborting backup."; echo
+               ErrorMsg "Aborting backup."; echo
                exit 5
        fi
        sleep 2
@@ -501,11 +509,11 @@ for f in "${sys[@]}"; do
 
        # Check target directory
        if [ -z "$target" ]; then
-               echo "No target directory specified for \"$system\"!? Skipped!"
+               ErrorMsg "No target directory specified for \"$system\"!? Skipped!"
                echo; continue
        fi
        if [ ! -d "$target" ]; then
-               echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
+               ErrorMsg "Target \"$target\" is not a directory!? \"$system\" skipped!"
                echo; continue
        fi
 
@@ -518,7 +526,7 @@ for f in "${sys[@]}"; do
                        mkdir -p "$sys_target"; r=$?
                fi
                if [ $r -ne 0 ]; then
-                       echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
+                       ErrorMsg "Can't create \"$sys_target\"!? \"$system\" skipped!"
                        echo; continue
                fi
        fi
@@ -526,7 +534,7 @@ for f in "${sys[@]}"; do
        if [[ "$local" -eq 0 && "$ping" -ne 0 ]]; then
                # Check if system is alive
                if ! ping -c 1 "$system" >/dev/null 2>&1; then
-                       echo "Host \"$system\" seems not to be alive!? Skipped."
+                       ErrorMsg "Host \"$system\" seems not to be alive!? Skipped."
                        echo; continue
                fi
                echo "OK, host \"$system\" seems to be alive."
@@ -537,7 +545,7 @@ for f in "${sys[@]}"; do
                if [ -e "$sys_target/.stamp" ]; then
                        # There seems to be a genearation-less backup in the
                        # target directory!
-                       echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
+                       ErrorMsg "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
                        echo; continue
                fi
 
@@ -548,7 +556,7 @@ for f in "${sys[@]}"; do
                        echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
                        if [ "$DRYRUN" -eq 0 ]; then
                                if ! RenameSubvolume "$last" "$sys_target"; then
-                                       echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
+                                       ErrorMsg "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
                                        echo; continue
                                fi
                        else
@@ -560,7 +568,7 @@ for f in "${sys[@]}"; do
                        if [ "$DRYRUN" -eq 0 ]; then
                                CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
                                if [ $r -ne 0 ]; then
-                                       echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
+                                       ErrorMsg "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
                                        echo; continue
                                fi
                                echo "Created new snapshot in \"$snapshot\"."
@@ -572,7 +580,7 @@ for f in "${sys[@]}"; do
                        if [ "$DRYRUN" -eq 0 ]; then
                                CreateSubvolume "$sys_target"; r=$?
                                if [ $r -ne 0 ]; then
-                                       echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
+                                       ErrorMsg "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
                                        echo; continue
                                fi
                                echo "Created new subvolume in \"$sys_target\"."
@@ -590,7 +598,7 @@ for f in "${sys[@]}"; do
                ExecJob pre "$job_pre_exec" ; ret=$?
                if [ $ret -ne 0 ]; then
                        [ $ret -ne 99 ] && count_started=$count_started+1
-                       echo "Pre-exec command failed, \"$system\" skipped!"
+                       ErrorMsg "Pre-exec command failed, \"$system\" skipped!"
                        echo; continue
                fi
        fi
@@ -641,7 +649,7 @@ for f in "${sys[@]}"; do
                        cmd="$cmd ${user}@${system}:$file $sys_target/"
                done
        else
-               echo "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
+               ErrorMsg "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
                echo; continue
        fi
 
@@ -674,7 +682,7 @@ for f in "${sys[@]}"; do
        fi
 
        if [ $ret -eq 20 ]; then
-               echo "Backup of \"$system\" interrupted. Aborting ..."
+               ErrorMsg "Backup of \"$system\" interrupted. Aborting ..."
                GotSignal
        fi
 
@@ -686,7 +694,7 @@ for f in "${sys[@]}"; do
                [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
                ok=1
        else
-               echo "System \"$system\" completed with ERRORS, code $ret!"
+               ErrorMsg "System \"$system\" completed with ERRORS, code $ret!"
        fi
 
        # execute job "post-exec" command, if any
@@ -711,7 +719,7 @@ for f in "${sys[@]}"; do
                        for delete in $to_delete; do
                                dir="$sys_root/$delete"
                                if [ ! -e "$dir/.stamp" ]; then
-                                       echo "Not deleting \"$dir\", not a backup directory!?"
+                                       ErrorMsg "Not deleting \"$dir\" of \"$system\", not a backup directory!?"
                                        continue
                                fi
                                last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
@@ -720,12 +728,12 @@ for f in "${sys[@]}"; do
                                echo "Removing backup from" $last "..."
                                if [ "$DRYRUN" -eq 0 ]; then
                                        DeleteSubvolume "$dir" \
-                                               || echo "Failed to delete \"$dir\"!"
+                                               || ErrorMsg "Failed to delete \"$dir\" of \"$system\"!"
                                fi
                        done
                        echo -n "Clean up finished: "; date
                elif [ -n "$to_delete" ]; then
-                       echo "There have been errors, not cleaning up old generations!"
+                       ErrorMsg "There have been errors for \"$system\", not cleaning up old generations!"
                else
                        echo "Nothing to clean up (keep up to $generations generations)."
                fi